<?php

//==============================================================================

$dirname = dirname(__FILE__);

//==============================================================================

if (!file_exists($dirname.'/conf.php')) {
  die ('Config file doesn\' exist!');
}

//==============================================================================

require_once($dirname.'/conf.php');
require_once($dirname.'/dict.php');
require_once($dirname.'/Snoopy.class.php');

//==============================================================================

$web_client = new Snoopy();

//==============================================================================

if (!($src_file = fopen($dirname.'/'.$_CONF['src_file'], 'r'))) {
  die ('Sorce file open error!');
}
if (!($dest_file = fopen($dirname.'/'.$_CONF['dest_file'], 'w+'))) {
  die ('Destination file open error!');
}

while (!feof($src_file)) {
  $anchors = '';

  $url = trim(fgets($src_file, 4098));
  $keyword = parseUrl($url);

  if (!$keyword) {
    continue;
  }

  if ((int) $_CONF['use_anchors']) {
    $query = str_replace(' ', '+', $keyword);
    $web_client->fetchsnippets(
      $_CONF['search_url'].'?q='.$query.'&start=0&num='.$_CONF['snippet_cnt']);

    $page = $web_client->results;
    $anchors = parseAnchors($page, $keyword, $_DICT, $_CONF['anchors_cnt']);
  }

  $text  = '<a href="'.$url.' ">'.$keyword.'</a> '.$anchors."\n";
  $text .= '[URL='.$url.']'.$keyword.'[/URL] '.$anchors."\n";

  fwrite($dest_file, $text);
}

fclose($dest_file);
fclose($src_file);

echo 'Done';

//==============================================================================

function parseUrl($aUrl)
{
  if (!trim($aUrl)) {
    return '';
  }

  $keyword = '';

  $url_parts = explode('/', $aUrl);

  $page_name_full = end($url_parts);
  $page_name      = reset(explode('.', $page_name_full));

  $keyword = str_replace(array('-', '_'), ' ', $page_name);
  $keyword = str_replace('  ', ' ', $keyword);

  return $keyword;
}

//==============================================================================

function parseAnchors($aPage, $aKeyword, $aDict, $aAnchorCnt)
{
  if (!trim($aPage)) {
    return '';
  }

  $anchors = array();
  $keywords = explode(' ', $aKeyword);

  $words = explode(' ', $aPage);
  foreach ($words as $word) {
    $word = trim($word);

    if (in_array($word, $keywords) || in_array($word, $anchors) ||
      in_array($word, $aDict) || (strlen($word) < 3))
    {
      continue;
    }
    else if (count($anchors) > $aAnchorCnt) {
      break;
    }

    $anchors[] = $word;
  }

  return ('{'.implode('|', $anchors).'}');
}

//==============================================================================